> For clean Markdown of any page, append .md to the page URL. > For a complete documentation index, see https://docs.mangopay.com/api-reference/refunds/create-refund-transfer/llms.txt. > For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.mangopay.com/_mcp/server. # Create a Refund for a Transfer POST https://api.sandbox.mangopay.com/v2.01/{ClientId}/transfers/{TransferId}/refunds Content-Type: application/json You can do a partial refund by providing a debited funds `Amount` value lower than the initial transaction amount. The debited funds amount must be 1 or more, if it is included. [Read more about transfer refunds](/guides/refunds#transfer-refunds) **→** Reference: https://docs.mangopay.com/api-reference/refunds/create-refund-transfer ## Authentication - `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer `, where token is your auth token. If your platform is using a [proxy](/guides/sca/proxy-management) to take SCA-triggering action on behalf of users, you also need to integrate [mTLS authentication](/guides/sca/platform) and use the `api-mtls` base URL. ## Servers - `https://api.sandbox.mangopay.com` (Sandbox, default) - `https://api.mangopay.com` (Production) - `https://api-mtls.sandbox.mangopay.com` (mTLS Sandbox) - `https://api-mtls.mangopay.com` (mTLS Production) ## Request ### Path parameters - `ClientId` (string, required) — Platform's API account identifier, associated with the API key. - `TransferId` (string, required) — The unique identifier of the transfer. ### Body (application/json) This endpoint expects a CreateARefundForATransferRequest. - `AuthorId` (string, required) — The unique identifier of the user at the source of the initial transaction. - `Tag` (string, optional) — Max. length: 255 characters Custom data that you can add to this object, such as unique identifiers in your system. To store multiple values, you can serialize them into a single string, for example a JSON object: `"{\"id_1\":AB123,\"id_2\":DE456}"`. - `DebitedFunds` (CreateARefundForATransferRequestDebitedFunds, optional) — Information about the debited funds. - `Fees` (CreateARefundForATransferRequestFees, optional) — Information about the fees. ## Response ### 200 Success - `Id` (string, optional) — Max length: 128 characters (see [data formats](/api-reference/overview/data-formats) for details) The unique identifier of the object. - `Tag` (string, optional) — Max. length: 255 characters Custom data that you can add to this object, such as unique identifiers in your system. To store multiple values, you can serialize them into a single string, for example a JSON object: `"{\"id_1\":AB123,\"id_2\":DE456}"`. - `CreationDate` (integer, optional) — Unix timestamp (UTC) of the date and time the object was created. - `AuthorId` (string, optional) — The unique identifier of the user at the source of the initial transaction. - `CreditedUserId` (string, optional) — **Default value:** The unique identifier of the owner of the credited wallet. The unique identifier of the user whose wallet is credited. - `DebitedFunds` (TransferRefundResponseDebitedFunds, optional) — Information about the debited funds. - `CreditedFunds` (TransferRefundResponseCreditedFunds, optional) — Information about the credited funds (`CreditedFunds` = `DebitedFunds` - `Fees`). - `Fees` (TransferRefundResponseFees, optional) — Information about the fees. - `Status` (string, optional) — **Returned values:** `CREATED`, `SUCCEEDED`, `FAILED` The status of the transaction. - `ResultCode` (string, optional) — The code indicating the result of the operation. This information is mostly used to handle errors or for filtering purposes. - `ResultMessage` (string, optional) — The explanation of the result code. - `ExecutionDate` (integer, optional) — Unix timestamp (UTC) of the date and time the status changed to `SUCCEEDED`, indicating that the transaction occurred. The statuses `CREATED` and `FAILED` return an `ExecutionDate` of `null`. - `Type` (string, optional) — **Returned values:** `PAYIN`, `TRANSFER`, `CONVERSION`, `PAYOUT` The type of the transaction. - `Nature` (string, optional) — **Returned values:** `REGULAR`, `REPUDIATION`, `REFUND`, `SETTLEMENT` The nature of the transaction, providing more information about the context in which the transaction occurred: - `REGULAR` – Relative to most of the transactions (pay-ins, payouts, and transfers) in a usual workflow. - `REPUDIATION` – Automatic withdrawal of funds from the platform's repudiation wallet as part of the dispute process (when the user has requested a chargeback). - `REFUND` – Reimbursement of a transaction to the user (pay-in refund), to a wallet (transfer refund), or of a payout (payout refund, only initiated by Mangopay). - `SETTLEMENT` – Transfer made to the repudiation wallet by the platform to settle a lost dispute. - `InitialTransactionId` (string, optional) — The unique identifier of the initial transaction being refunded. - `InitialTransactionType` (string, optional) — **Returned values:** `PAYIN`, `TRANSFER`, `PAYOUT` The type of the initial transaction being refunded. - `InitialTransactionNature` (string, optional) — **Returned values:** `REGULAR`, `REPUDIATION`, `REFUND`, `SETTLEMENT` The nature of the initial transaction being refunded, providing more information about the context in which the transaction occurred: - REGULAR – Relative to most of the transactions (pay-ins, payouts, and transfers) in a usual workflow. - REPUDIATION – Automatic withdrawal of funds from the platform's repudiation wallet as part of the dispute process (when the user requested a chargeback). - REFUND – Reimbursement of a transaction to the user (pay-in refund), to a wallet (transfer refund), or of a payout (payout refund, only initiated by Mangopay). - SETTLEMENT – Transfer made to the repudiation wallet by the platform to settle the credit from a repudiation following a lost dispute. - `DebitedWalletId` (string, optional) — The unique identifier of the debited wallet. - `CreditedWalletId` (string, optional) — The unique identifier of the credited wallet. - `RefundReason` (TransferRefundResponseRefundReason, optional) — Information about the reasons for the refund. ## Errors ### 400 Bad Request Error Bad Request - `Message` (string, optional) — Description of the error. - `Type` (string, optional) — The category of the error. - `Id` (string, optional) — Unique identifier of the error instance, useful when contacting Mangopay for support. - `Date` (double, optional) — Unix timestamp (UTC) of the date and time the error was triggered. - `errors` (map from string to string, optional, nullable) — Object containing one or more field-level errors. ## Types ### CreateARefundForATransferRequestDebitedFunds Information about the debited funds. - `Currency` (string, required) — **Allowed values:** The three-letter ISO 4217 code (EUR, GBP, etc.) of a supported currency (depends on feature, contract, and activation settings). The currency of the amount. - `Amount` (integer, required) — The amount of the currency in its minor unit. For example, EUR 12.60 would be represented as `1260` whereas JPY 12 would be represented as just `12`. ### CreateARefundForATransferRequestFees Information about the fees. - `Currency` (string, required) — **Allowed values:** The three-letter ISO 4217 code (EUR, GBP, etc.) of a supported currency (depends on feature, contract, and activation settings). The currency of the amount. - `Amount` (integer, required) — The amount of the currency in its minor unit. For example, EUR 12.60 would be represented as `1260` whereas JPY 12 would be represented as just `12`. ### TransferRefundResponseDebitedFunds Information about the debited funds. - `Currency` (string, optional) — **Allowed values:** The three-letter ISO 4217 code (EUR, GBP, etc.) of a supported currency (depends on feature, contract, and activation settings). The currency of the amount. - `Amount` (integer, optional) — The amount of the currency in its minor unit. For example, EUR 12.60 would be represented as `1260` whereas JPY 12 would be represented as just `12`. ### TransferRefundResponseCreditedFunds Information about the credited funds (`CreditedFunds` = `DebitedFunds` - `Fees`). - `Currency` (string, optional) — **Allowed values:** The three-letter ISO 4217 code (EUR, GBP, etc.) of a supported currency (depends on feature, contract, and activation settings). The currency of the amount. - `Amount` (integer, optional) — The amount of the currency in its minor unit. For example, EUR 12.60 would be represented as `1260` whereas JPY 12 would be represented as just `12`. ### TransferRefundResponseFees Information about the fees. - `Currency` (string, optional) — **Allowed values:** The three-letter ISO 4217 code (EUR, GBP, etc.) of a supported currency (depends on feature, contract, and activation settings). The currency of the amount. - `Amount` (integer, optional) — The amount of the currency in its minor unit. For example, EUR 12.60 would be represented as `1260` whereas JPY 12 would be represented as just `12`. ### TransferRefundResponseRefundReason Information about the reasons for the refund. - `RefundReasonMessage` (string, optional) — Message explaining the reason for the refusal. - `RefundReasonType` (string, optional) — **Returned values:** `INITIALIZED_BY_CLIENT`, `BANKACCOUNT_INCORRECT`, `OWNER_DO_NOT_MATCH_BANKACCOUNT`, `BANKACCOUNT_HAS_BEEN_CLOSED`, `WITHDRAWAL_IMPOSSIBLE_ON_SAVINGS_ACCOUNTS`, `OTHER` The type of reason for the refund. ## Examples **Request** ```json { "body": { "AuthorId": "146476890", "Tag": "custom meta" } } ``` **Response** ```json { "Id": "155586343", "Tag": "custom meta", "CreationDate": 1667916816, "AuthorId": "146476890", "CreditedUserId": null, "DebitedFunds": { "Currency": "EUR", "Amount": 1100 }, "CreditedFunds": { "Currency": "EUR", "Amount": 1120 }, "Fees": { "Currency": "EUR", "Amount": -20 }, "Status": "SUCCEEDED", "ResultCode": "000000", "ResultMessage": "Success", "ExecutionDate": 1667916816, "Type": "TRANSFER", "Nature": "REFUND", "InitialTransactionId": "155585643", "InitialTransactionType": "TRANSFER", "InitialTransactionNature": "REGULAR", "DebitedWalletId": "152161320", "CreditedWalletId": "148968396", "RefundReason": { "RefundReasonMessage": null, "RefundReasonType": "OTHER" } } ``` **SDK Code** ```python from pprint import pprint import mangopay mangopay.client_id='your-client-id' mangopay.apikey='your-api-key' from mangopay.api import APIRequest handler = APIRequest(sandbox=True) from mangopay.resources import NaturalUser, TransferRefund, Transfer natural_user = NaturalUser.get('211918806') user_transfer = Transfer.get('214568995') transfer_refund = TransferRefund( author = natural_user, transfer = user_transfer ) create_transfer_refund = transfer_refund.save() pprint(create_transfer_refund) ``` ```javascript const mangopayInstance = require('mangopay4-nodejs-sdk') const mangopay = new mangopayInstance({ clientId: 'your-client-id', clientApiKey: 'your-api-key', }) let myTransfer = { Id: '180974208', } let myRefund = { AuthorId: '170853400', Tag: 'Created using Mangopay Node.js SDK', } const createRefund = async (transferId, refund) => { return await mangopay.Transfers.createRefund(transferId, refund) .then((response) => { console.info(response) return response }) .catch((err) => { console.log(err) return false }) } createRefund(myTransfer.Id, myRefund) ``` ```java import com.google.gson.Gson; import com.google.gson.GsonBuilder; import com.mangopay.MangoPayApi; import com.mangopay.core.Money; import com.mangopay.core.enumerations.CurrencyIso; import com.mangopay.entities.Refund; public class CreateTransferRefund { public static void main(String[] args) throws Exception { MangoPayApi mangopay = new MangoPayApi(); mangopay.getConfig().setClientId("your-client-id"); mangopay.getConfig().setClientPassword("your-api-key"); var authorId = "user_m_01HQK25M6KVHKDV0S36JY9NRKR"; var transferId = "xfer_m_01J1WJCSBG0S4637BR54YYJX0Z"; Refund refund = new Refund(); refund.setAuthorId(authorId); refund.setDebitedFunds(new Money(CurrencyIso.EUR, 500)); refund.setFees(new Money(CurrencyIso.EUR, 0)); refund.setTag("Created using the Mangopay Java SDK"); Refund createPayinRefund = mangopay.getTransferApi().createRefund(transferId, refund); Gson prettyPrint = new GsonBuilder().setPrettyPrinting().create(); String prettyJson = prettyPrint.toJson(createPayinRefund); System.out.println(prettyJson); } } ``` ```csharp using MangoPay.SDK; using MangoPay.SDK.Core.Enumerations; using MangoPay.SDK.Entities; using MangoPay.SDK.Entities.POST; using Newtonsoft.Json; class Program { static async Task Main(string[] args) { MangoPayApi api = new MangoPayApi(); api.Config.ClientId = "your-client-id"; api.Config.ClientPassword = "your-api-key"; var userId = "user_m_01J2TZ261WZNDM0ZDRWGDYA4GN"; var transferId = "xfer_m_01J3ZG49W215VVZRJS394DKM00"; var refund = new RefundTransferPostDTO(userId); var createRefund = await api.Transfers.CreateRefundAsync(transferId, refund); string prettyPrint = JsonConvert.SerializeObject(createRefund, Formatting.Indented); Console.WriteLine(prettyPrint); } } ``` ```php Config->ClientId = 'your-client-id'; $api->Config->ClientPassword = 'your-api-key'; $api->Config->TemporaryFolder = 'tmp/'; try { $transferId = '199132726'; $refund = new \MangoPay\Refund(); $refund->AuthorId = '146476890'; $refund->DebitedFunds = new \MangoPay\Money(); $refund->DebitedFunds->Amount = 500; $refund->DebitedFunds->Currency = 'EUR'; $refund->Fees = new \MangoPay\Money(); $refund->Fees->Amount = 0; $refund->Fees->Currency = 'EUR'; $refund->Tag = 'Created using Mangopay PHP SDK'; $response = $api->Transfers->CreateRefund($transferId, $refund); print_r($response); } catch(MGPResponseException $e) { print_r($e); } catch(MGPException $e) { print_r($e); } ``` ```ruby require 'mangopay' MangoPay.configure do |client| client.preproduction = true client.client_id = 'your-client-id' client.client_apiKey = 'your-api-key' client.log_file = File.join(Dir.pwd, 'mangopay.log') end def createTransferRefund(transferId, refundObject) begin response = MangoPay::Transfer.refund(transferId, refundObject) puts response return response rescue MangoPay::ResponseError => error puts "Failed to create Refund: #{error.message}" puts "Error details: #{error.details}" return false end end myTransfer = { Id: '194579950' } myRefund = { AuthorId: '194579896', Tag: 'Created with Mangopay Ruby SDK' } createTransferRefund(myTransfer[:Id], myRefund) ```